﻿# -*- coding: utf-8 -*-


import copy
import math

#ベンド
#2011.09.22

#選択している頂点を弟階層の球の中心位置を中心に曲げて変形します

#上位パートに変換がかかっていると使用できません


#動作条件
#選択形状がポリゴンメッシュで一つのみ選択
#編集モードに入っている
#頂点選択モード
#頂点が二つ以上選択されている
#弟形状が存在し、かつ球である

#shade1301に対応


#設定項目
#回転の平面　「正面図で曲げる」「上面図で曲げる」「側面図で曲げる」
#角度　　（-360～360度）
#角度の反転
#固定位置　（最大、最小、数値）
#数値の場合
#参照軸　（X軸、Y軸、Z軸）


def return_kaiten(pos,cpos,kakudo2,ziku):
  #posをcposを中心にziku（0x軸、1y軸、2z軸）まわりにkakudoだけ回転させて返す

  kakudo=(2*math.pi*kakudo2)/360
#  kakudo=kakudo2


  tempos5=[pos[0]-cpos[0],pos[1]-cpos[1],pos[2]-cpos[2]]
  newpos=[tempos5[0],tempos5[1],tempos5[2]]

  if ziku==0:
    newpos[1]=tempos5[1]*math.cos(kakudo)-tempos5[2]*math.sin(kakudo)
    newpos[2]=tempos5[1]*math.sin(kakudo)+tempos5[2]*math.cos(kakudo)

  if ziku==1:
    newpos[2]=tempos5[2]*math.cos(kakudo)-tempos5[0]*math.sin(kakudo)
    newpos[0]=tempos5[2]*math.sin(kakudo)+tempos5[0]*math.cos(kakudo)

  if ziku==2:
    newpos[0]=tempos5[0]*math.cos(kakudo)-tempos5[1]*math.sin(kakudo)
    newpos[1]=tempos5[0]*math.sin(kakudo)+tempos5[1]*math.cos(kakudo)

  newpos=[newpos[0]+cpos[0],newpos[1]+cpos[1],newpos[2]+cpos[2]]
  return newpos




dousasuru=0

xscene=xshade.scene()
ashape=xshade.scene().active_shape()



if ashape.type==7 and xscene.is_modify_mode==True and len(xscene.active_shapes)==1:
  if xscene.selection_mode==2:
    aplist=[]#選択頂点リスト
    for i in range(ashape.total_number_of_control_points):
      if ashape.vertex(i).active==True:
        aplist.append(i)

    if len(aplist)>1:dousasuru=1


if dousasuru>0:
  #上位パートに変換がかかっているなら動作しない

  if xshade.scene().active_shape().local_to_world_matrix!=((1.0, 0.0, 0.0, 0.0), (0.0, 1.0, 0.0, 0.0), (0.0, 0.0, 1.0, 0.0), (0.0, 0.0, 0.0, 1.0)):
    dousasuru=0
    dialog=xshade.create_dialog()
    dialog.append_push_button('上位パートに変換がかかっているため')
    dialog.append_push_button('スクリプトが実行できません')
    
    dialog.ask('エラー')

if dousasuru>0:
  if ashape.has_bro==True:
    if ashape.bro.type!=5:dousasuru=0

  else:dousasuru=0



if dousasuru==1:

  #選択部のバウンディングボックス

  minx=ashape.vertex(aplist[0]).position[0]
  maxx=ashape.vertex(aplist[0]).position[0]
  miny=ashape.vertex(aplist[0]).position[1]
  maxy=ashape.vertex(aplist[0]).position[1]
  minz=ashape.vertex(aplist[0]).position[2]
  maxz=ashape.vertex(aplist[0]).position[2]

  minxp=aplist[0]
  minyp=aplist[0]
  minzp=aplist[0]
  maxxp=aplist[0]
  maxyp=aplist[0]
  maxzp=aplist[0]

  for i in aplist:
    tpos=ashape.vertex(i).position
    if tpos[0]<minx:
      minxp=i
      minx=tpos[0]

    if tpos[1]<miny:
      minyp=i
      miny=tpos[1]

    if tpos[2]<minz:
      minzp=i
      minz=tpos[2]

    if tpos[0]>maxx:
      maxxp=i
      maxx=tpos[0]

    if tpos[1]>maxy:
      maxyp=i
      maxy=tpos[1]

    if tpos[2]>maxz:
      maxzp=i
      maxz=tpos[2]

  minp=[minx,miny,minz]
  maxp=[maxx,maxy,maxz]


if dousasuru==1:

  #一つ目のダイアログ表示

  dialog11=xshade.create_dialog()
  idxa11=dialog11.append_radio_button('作業平面/正面図で曲げる/上面図で曲げる/側面図で曲げる')
  dialog11.set_value(idxa11,0)
  xshade.scene().update_figure_window()
  kekkaf=dialog11.ask('ベンド')

  if kekkaf==True:
    splane=dialog11.get_value(idxa11)

  else:dousasuru=0




if dousasuru==1:

  #元の形状をコピー
  ashape.copy()
  xscene.enter_modify_mode()

  #弟階層の球の中心位置取得
  scenter=ashape.bro.center

  #ここに初期値
  renzoku=1
  hanten=0
  kakudo=60 #角度
  kotei=0  #固定位置　0が最大　1が最小　2が数値
  suuti=0  #固定位置が数値の場合の場所
  refaxis=0 #参照軸　0がX軸、1がY軸、2がZ軸
  hazi=0
  hazi2=0

#  dfhk=hk
#  dfbunkatu=bunkatu

  while(renzoku==1):
    #ダイアログ表示
#    dialog=xshade.create_dialog_with_uuid('0x51900243')
    dialog=xshade.create_dialog()


#    dialog.append_default_button()

    idx1=dialog.append_double('角度(-360～360)')
    idx5=dialog.append_bool('角度の反転')

    if splane==0:
      idx2=dialog.append_radio_button('参照軸/X軸/Y軸')
    if splane==1:
      idx2=dialog.append_radio_button('参照軸/X軸/Z軸')
    if splane==2:
      idx2=dialog.append_radio_button('参照軸/Y軸/Z軸')

    idx3=dialog.append_radio_button('固定位置/最大/最小/数値')

    idx4=dialog.append_double('数値の場合')
    
    dialog.set_value(idx1,kakudo)
    dialog.set_value(idx5,hanten)
    dialog.set_value(idx2,hazi)
    dialog.set_value(idx3,hazi2)
    dialog.set_value(idx4,suuti)


#    dialog.set_default_value(idx2,dfhk)
#    dialog.set_default_value(idx3,dfbunkatu)

    xshade.idle(120)
    xshade.scene().update_figure_window()

    kekka=dialog.ask('ベンド')

    if kekka==False:renzoku=0

    else:
      kakudo=dialog.get_value(idx1)
      if kakudo>360:kakudo=360
      if kakudo<-360:kakudo=-360

      hanten=dialog.get_value(idx5)
      if hanten==0:thanten=1
      else:thanten=-1

      suuti=dialog.get_value(idx4)

      hazi2=dialog.get_value(idx3)
      kotei=hazi2
      hazi=dialog.get_value(idx2)

      if splane==0:
        if hazi==0:refaxis=0
        else:refaxis=1

      if splane==1:
        if hazi==0:refaxis=0
        else:refaxis=2

      if splane==2:
        if hazi==0:refaxis=1
        else:refaxis=2

      #最大幅を求める

      if refaxis==0:
        if kotei==0:tempcenter=maxx
        if kotei==1:tempcenter=minx
        if kotei==2:tempcenter=suuti

        haba1=abs(maxx-tempcenter)
        haba2=abs(minx-tempcenter)
        if haba1>haba2:shaba=haba1
        else: shaba=haba2

      if refaxis==1:
        if kotei==0:tempcenter=maxy
        if kotei==1:tempcenter=miny
        if kotei==2:tempcenter=suuti

        haba1=abs(maxy-tempcenter)
        haba2=abs(miny-tempcenter)
        if haba1>haba2:shaba=haba1
        else: shaba=haba2

      if refaxis==2:
        if kotei==0:tempcenter=maxz
        if kotei==1:tempcenter=minz
        if kotei==2:tempcenter=suuti

        haba1=abs(maxz-tempcenter)
        haba2=abs(minz-tempcenter)
        if haba1>haba2:shaba=haba1
        else: shaba=haba2


      #頂点ごとに回転
      for i in aplist:
        tempos=[ashape.vertex(i).position[0],ashape.vertex(i).position[1],ashape.vertex(i).position[2]]


        #回転角度を求める
        rkakudo=kakudo*(tempos[refaxis]-tempcenter)/shaba


        #固定位置へ落とす
        if refaxis==0:
          tempos[0]=tempcenter

        if refaxis==1:
          tempos[1]=tempcenter

        if refaxis==2:
          tempos[2]=tempcenter

        #軸周りに回転

#        if splane==0:  #正面図で曲げる場合
#          tempab=[tempos[0],tempos[1]]
#          tempcenter=[scenter[0],scenter[1]]
#          tempab=return_kaiten(tempab,tempcenter,rkakudo,2)
#          tempos[0]=tempab[0]
#          tempos[1]=tempab[1]

#        if splane==1:  #上面図で曲げる場合
#          tempab=[tempos[0],tempos[2]]
#          tempcenter=[scenter[0],scenter[2]]
#          tempab=return_kaiten(tempab,tempcenter,rkakudo,1)
#          tempos[0]=tempab[0]
#          tempos[2]=tempab[1]

#        if splane==2:  #側面図で曲げる場合
#          tempab=[tempos[1],tempos[2]]
#          tempcenter=[scenter[1],scenter[2]]
#          tempab=return_kaiten(tempab,tempcenter,rkakudo,0)
#          tempos[1]=tempab[0]
#          tempos[2]=tempab[1]

        if splane==0:
          tempos=return_kaiten(tempos,scenter,rkakudo*thanten,2)

        if splane==1:
          tempos=return_kaiten(tempos,scenter,rkakudo*thanten,1)

        if splane==2:
          tempos=return_kaiten(tempos,scenter,rkakudo*thanten,0)


        ashape.vertex(i).position=[tempos[0],tempos[1],tempos[2]]


      #選択箇所の再選択
#      xshade.scene().enter_modify_mode()
#      for i in aplist:
#        ashape.vertex(i).active=True      



      #元に戻すか聞く
      dialog=xshade.create_dialog()
      idx3=dialog.append_push_button('処理を確定しますか?')
      xshade.idle(120)
      xshade.scene().update_figure_window()

      kekka=dialog.ask('ベンド')

      if kekka==True:renzoku=0

      if kekka==False:
        idou1=0
        if xshade.scene().active_shape().has_sis==True:
          idou1=1
        xshade.scene().paste()
        xshade.scene().select_sister(1)
        xshade.scene().clear()
        if idou1==1:
          xshade.scene().select_brother()
        xshade.scene().enter_modify_mode()
        ashape=xshade.scene().active_shape() 
        for i in aplist:
          ashape.vertex(i).active=True





